<?php defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: weblink.php,v 1.14 2010-02-14 18:44:17 neschkeh Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.model');

class LinkDirectory2ModelWeblink extends JModel {
	
	private $_id = null;
	private $_data = null;

	/**
	 */
	public function __construct() {
		parent::__construct();
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$edit = JRequest::getVar('edit',true);
		if($edit) {
			$this->setId((int)$array[0]);
		}
	}

	/**
	 */
	private function setId($id) {
		$this->_id		= $id;
		$this->_data	= null;
	}

	/**
	 * Liefert alle Daten eines Links inkl. einige Daten der Kategorie: 
	 * cc.title AS category
	 * cc.published AS categoryPublished 
	 * cc.access AS categoryAccess 
	 */
	public function &getData()	{
		if (!$this->_loadData()) {
			$this->_initData();
		}
		return $this->_data;
	}

	/**
	 * Liefert true, wenn Weblink von einem anderen User ausgecheckt worden ist, sonst false.  
	 */
	public function isCheckedOut( $userId=0 ) {
		if ($userId === 0) {
			$user		= &JFactory::getUser();
			$userId		= (int) $user->get('id');
		}
		if ($this->_loadData()) {
			if ($userId) {
				//       true, wenn ausgescheckt  && true, wenn von einem anderen ausgescheckt    
				return ($this->_data->checked_out && $this->_data->checked_out != $userId);
			} else {
				return $this->_data->checked_out;
			}
		}
	}

	/**
	 * Checkt den jeweiligen Eintrag wieder ein.
	 * @return false, wenn ein Datenbankfehler aufgetreten ist, sonst false
	 */
	public function checkin() {
		if ($this->_id) {
			$weblink = & $this->getTable();
			if(! $weblink->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			return true;
		}
		return true;
	}

	/**
	 *
	 */
	public function checkout($uid = null) {
		if ($this->_id) {
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			$weblink = & $this->getTable();
			if(!$weblink->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			return true;
		}
		return false;
	}

	/**
	 *
	 */
	public function store($data) {
		$row =& $this->getTable();
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if ($row->id < 1){
			$row->created = gmdate('Y-m-d H:i:s');
		}
		$row->modified = gmdate('Y-m-d H:i:s');
		if (!$row->id) {
			$where = 'catid = ' . (int) $row->catid ;
			$row->ordering = $row->getNextOrder( $where );
		}
		if (!$row->check()) {
			$this->setError($row->getErrorMsg());
			return false;
		}
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}

	/**
	 * Löscht ein oder mehrere WebLinks
	 * @param array $cid Array mit den zu löschenden Ids
	 * @return false, wenn Datenbankfehler aufgetreten ist, sonst true
	 */
	public function delete($cid = array()) {
		$result = false;

		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__ldlinks'
				. ' WHERE id IN ( '.$cids.' )'
				;
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	/**
	 * 
	 */
	public function publish($cid = array(), $publish = 1) {
		$user 	=& JFactory::getUser();
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'UPDATE #__ldlinks'
				. ' SET published = '.(int) $publish
				. ' WHERE id IN ( '.$cids.' )'
				. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
			;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	/**
	 */
	public function move($direction) {
		$row =& $this->getTable();
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->move( $direction)) {//, ' catid = '.(int) $row->catid.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}	
	
	/**
	 *
	 */
	public function saveorder($cid = array(), $order) {
		$row =& $this->getTable();
		$groupings = array();

		for( $i=0; $i < count($cid); $i++ ) {
			$row->load( (int) $cid[$i] );
			$groupings[] = $row->catid;
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// TODO Ünerprüfen, was damit ist
		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('catid = '.(int) $group);
		}
		return true;
	}

	/**
	 *
	 */
	private function _loadData() { 
		if (empty($this->_data)) {
			$query = 'SELECT w.*, cc.title AS category, '.
					' cc.published AS categoryPublished, cc.access AS categoryAccess '.
					' FROM #__ldlinks AS w ' .
					' LEFT JOIN #__ldcats AS cc ON cc.id = w.catid ' .
					' WHERE w.id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}

	/**
	 *
	 */
	private function _initData() {
		if (empty($this->_data)) {
			$weblink = new stdClass();
			$weblink->id = 0;
			$weblink->catid = 0;
			$weblink->title = null;
			$weblink->url = null;
			$weblink->thumburl = null;
			$weblink->image = null;
			$weblink->description = null;
			$weblink->description_long = null;
			$weblink->created = null;
			$weblink->modified = null;
			$weblink->hits = 0;
			$weblink->rating = 0;
			$weblink->votes = 0;
			$weblink->published = 0;
			$weblink->checked_out = null;
			$weblink->checked_out_time = null;
			$weblink->ordering = 0;
			$weblink->params = null;
			$weblink->category = 0;
			$weblink->categoryPublished=0;
			$weblink->categoryAccess=0;
			$this->_data = $weblink;
			return (boolean) $this->_data;
		}
		return true;
	}
}