<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: CaptchaUtils.php,v 1.6 2010-02-08 20:46:29 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';

class CaptchaUtils {
	
	const EASYCAPTCHA = 'easycaptcha';
	const SECURITYIMAGES5 = 'securityimages5';

	public function validateCaptcha (){
		$ld=new LDConfig();
		if (!self::isCaptchaEnable()) return true;
		$checkSecurity = false;
		switch($ld->securityimage) {
			case self::EASYCAPTCHA:
				$captcha_id = strval( mosGetParam( $_POST, 'captcha_id', '' ) );
				$captcha_code = strval( mosGetParam( $_POST, 'captcha_code', '' ) );
				include_once(JPATH_BASE.'/components/com_easycaptcha/class.easycaptcha.php');
				$captcha = new EasyCaptcha($captcha_id);
				$checkSecurity = $captcha->checkEnteredCode($captcha_code);
				break;
			case self::SECURITYIMAGES5:
				$userEntry = JRequest::getVar('securityImagesmy3rdpartyExtensions', false, '', 'CMD');
				$mainframe = JFactory::getApplication();
				$mainframe->triggerEvent('onSecurityImagesCheck', array($userEntry, &$check));
				$checkSecurity = $check;
				break;
			default:
				$checkSecurity = true;
		}
		return $checkSecurity;
	}

	public function isCaptchaEnable(){
		$ld = new LDConfig();
		$user=JFactory::getUser();
		$return = false;
		switch($ld->securityimage) {
			case self::EASYCAPTCHA:
				if (JComponentHelper::isEnabled('com_easycaptcha',true)) {
					return true;
				}
				break;

			case self::SECURITYIMAGES5:
				if (JComponentHelper::isEnabled('com_securityimages',true)){
					global $securitySwitchOffGlobally;
					if (!$securitySwitchOffGlobally  AND !$user->gid){
						return true;
					}
				}
				break;
		}
		return false;
	}

	public function displayCaptcha (){
		$ld = new LDConfig();
		$html='';
		switch($ld->securityimage) {
			case self::EASYCAPTCHA:
				include_once(JPATH_BASE.'/components/com_easycaptcha/class.easycaptcha.php');
				$captcha = new easyCaptcha();
				if($captcha->captcha_id) {
					$html.='<input type="hidden" name="captcha_id" value="';
					$html.=$captcha->getCaptchaId() . '" />';
					$html.='<img src="';
					$html.=$captcha->getImageUrl();
					$html.=' alt="'.$captcha->getAltText();
					$html.='" id="code" />'.$captcha->getReloadButton("code").$captcha->getReloadCode();
					$html.='<br />';
					$html.='<br />';
					$html.='<input type="text" name="captcha_code" id="contact_captcha" class="inputbox" />';
				}
				break;
			case self::SECURITYIMAGES5:
				?>
				<script
					type="text/javascript"
					src="components/com_securityimages/js/securityImages.js"></script>
				<input
					type="text" name="securityImagesmy3rdpartyExtensions" align="middle" />
				&nbsp;
				<img id='captchaSecurityImages'
					name='captchaSecurityImages'
					src="index.php?option=com_securityimages&task=displaycaptcha"
					align="middle">
				&nbsp;
				<a href="javascript:askNewSecurityImages('captchaSecurityImages');"><img
					src="components/com_securityimages/buttons/reload.gif"
					id="securityImagesContactCaptchaReload"
					name="securityImagesContactCaptchaReload" border="0" align="middle"></a>
				<?php
				break;
			default:
				$html='';
		}
		return $html;
	}
}

?>