<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: link.php,v 1.23 2010-02-15 19:41:46 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport( 'joomla.application.component.model' );

require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php');

class LinkDirectory2ModelLink extends JModel {

	private $_ld;
	
	private $_id = null;
	private $_data = null;

	private $_comments = null;

	private $_searchComments = null;
	private $_totalComments = null;
	private $_paginationComments = null;
	private $_queryComments = null;
	
	public function __construct(){
		parent::__construct();
		$id = JRequest::getVar('id', 0, '', 'int');
		$this->setId((int)$id);
		$this->_ld=new LDConfig();
	}

	public function setId($id) {
		$this->_id		= $id;
		$this->_data	= null;
	}
		
	/**
	 *
	 */
	public function &getData() {
		if (!$this->_loadData()){ 
			$this->_initData();
		}
		return $this->_data;
	}
	
	/**
	 * Nach dem Speichern entält _data und _id die entsprechenden Werte
	 */
	function store($data) {
		$row =& $this->getTable();
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if ($row->id < 1){
			$row->created = gmdate('Y-m-d H:i:s');
		}
		$row->modified = gmdate('Y-m-d H:i:s');
		if (!$row->id) {
			$where = 'catid = ' . (int) $row->catid ;
			$row->ordering = $row->getNextOrder( $where );
		}
		if (!$row->check()) {
			$this->setError($row->getError());
			return false;
		}
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		$this->_data = &$row ;
		$this->_id = $row->id;
		
		return true;
	}
	
	
	
	private function _loadData() {
		if (empty($this->_data)) {
			$query = 'SELECT l.*, c.title AS cat_title, c.published AS cat_published, c.access AS categoryAccess '
				. ' FROM #__ldlinks AS l ' 
				. ' LEFT JOIN #__ldcats AS c ON c.id = l.catid' 
				. ' WHERE l.id = '. (int) $this->_id
				;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}
	
	private function _initData(){
		if (empty($this->_data)) {
			$weblink = new stdClass();
			$weblink->id		= 0;
			$weblink->catid		= 0;
			$weblink->title = null;
			$weblink->url = null;
			$weblink->thumburl = null;
			$weblink->image = null;
			$weblink->description = null;
			$weblink->description_long = null;
			$weblink->created = null;
			$weblink->modified = null;
			$weblink->hits = 0;
			$weblink->rating = 0;
			$weblink->votes = 0;
			$weblink->published = 0;
			$weblink->checked_out = null;
			$weblink->checked_out_time = null;
			$weblink->ordering = 0;
			$weblink->params = null;	
			$this->_data = $weblink;
			return (boolean) $this->_data;
		}
		return true;
	}
	
	// =======================================================================
	// =                   Comments                                          =
	// =======================================================================
	public function &getCommentsData() {
		$pagination =& $this->getPaginationComments();
		if (empty($this->_comments)) {
			$query = $this->buildSearchComments();
			$this->_comments = $this->_getList($query, $pagination->limitstart, $pagination->limit);
		}
		return $this->_comments;
	}

	public function &getPaginationComments() {
		if(!$this->_paginationComments) {
			jimport('joomla.html.pagination');
			global $mainframe;
			$this->_paginationComments = new JPagination($this->getTotalComments(), JRequest::getVar('limitstart', 0), $this->_ld->limitcomment);
		}
		return $this->_paginationComments;
	}

	public function getTotalComments() {
		if (!$this->_totalComments) {
			$query = $this->buildSearchComments();
			$this->_totalComments = $this->_getListCount($query);
		}
		return $this->_totalComments;
	}

	private function buildSearchComments() {
		if (!$this->_queryComments) {
			$search = $this->getSearchComments();
			$this->_queryComments = "SELECT c.* ,u.name as realname, u.username  FROM #__ldcomment as c Left outer join  #__users as u on c.user_id = u.id ";
			if ($search != '') {
				$search = $this->_db->getEscaped( $search, true );
				$this->_queryComments .= " WHERE c.link_id = {$search} AND c.rev_approved = 1 ";
			}
			$this->_queryComments .= ' ORDER BY c.rev_id DESC';
		}
		return $this->_queryComments;
	}

	private function getSearchComments() {
		if (!$this->_searchComments) {
			if ($this->_id == 0){
				$id = JRequest::getInt('id',0);
			} else {
				$id = $this->_id;
			}
			$this->_searchComments = JString::strtolower($id);
		}
		return $this->_searchComments;
	}

	// =======================================================================
	// =                   Rate  a Link                                        =
	// =======================================================================
	/**
	* Liefert true, wenn Rating im Berecih 1 bis 5 ist, ansonsten false.
	*
	* @param int $rating Rating
	* @return true, wenn Rating im Bereich 1 bis 5
	*/
	public function checkRating($rating){
		$rating = intval($rating);
		if ( $rating < 1 || $rating > 5 ) {
			# Invalid rating. User did not fill in rating, or attempt misuse
			return false;
		}
		return true;
	}


	/**
	 * Modifiziert das Rating
	 *
	 * @param int $id des Links, des Bewertung aktualisiert werden soll
	 * @param int $rating Rating, das hinzugefügt werden soll
	 * @return true, wenn update erfolgreich war, sonst false
	 */
	public function updateRating($id,$rating){
		$id = intval($id);
		$rating=intval($rating);
		if (! $this->checkRating($rating)){
			return false;
		}
		$query = "UPDATE #__ldlinks l , #__ldcats c "
		.	" SET rating = ((l.rating * l.votes)+$rating)/(l.votes+1), l.votes = l.votes +1 "
		.	"WHERE l.id = $id and l.published = 1 and ( l.catid = c.id and c.published = 1 OR l.catid = 0) " ;
		$this->_db->setQuery($query);
		if (!$this->_db->query()){
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		// TODO getNumRows schein kein verwertbares Ergebnis zu liefern. Prüfen und ggf. Alternativen einbauen
//		if ($this->_db->getNumRows()!= 1 ){
//			dump("Anzahl Rows != 1: [".$this->_db->getNumRows()."]");
//			return false;
//		}
		return true;
	}

	public function increaseHitCounter($id){
		$cookiename = "ldhit$id";
		$visited = JRequest::getVar($cookiename,'0','cookie');

		if (!$visited) {
			$query =  "UPDATE #__ldlinks SET hits=hits+1 WHERE id=$id";
			$this->_db->setQuery($query);
			if (!$this->_db->query()){
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			setcookie( $cookiename, '1', time()+86400 );
			return true;
		}
		return false;
	}
}
?>